(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators'), require('object-hash'), require('@sd-angular/core/cache'), require('uuid')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/api', ['exports', '@angular/core', '@angular/common/http', 'rxjs', 'rxjs/operators', 'object-hash', '@sd-angular/core/cache', 'uuid'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.api = {}), global.ng.core, global.ng.common.http, global.rxjs, global.rxjs.operators, global['object-hash'], global['sd-angular'].core.cache, global.uuid));
}(this, (function (exports, i0, i1, rxjs, operators, hash, i2, uuid) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    var API_CONFIG = new i0.InjectionToken('api.configuration');
    var TOKEN = hash__default['default']({
        origin: location.origin,
        key: 'ed4a2ffc-af43-41fb-9ac9-970f43d99571'
    });

    var SdTokenService = /** @class */ (function () {
        function SdTokenService(configuration, cacheService) {
            var _this = this;
            this.configuration = configuration;
            this.cacheService = cacheService;
            this.set = function (token) {
                var set = _this.cacheService.create(TOKEN, {
                    type: 'local',
                    hours: 240
                }).set;
                set(token);
            };
            this.clear = function () {
                var remove = _this.cacheService.create(TOKEN, {
                    type: 'local',
                    hours: 240
                }).remove;
                remove();
            };
            this.customHeaders = function (args) {
                var _a, _b;
                return ((_b = (_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.customHeaders) === null || _b === void 0 ? void 0 : _b.call(_a, args)) || null;
            };
        }
        Object.defineProperty(SdTokenService.prototype, "token", {
            get: function () {
                var get = this.cacheService.create(TOKEN, {
                    type: 'local',
                    hours: 240
                }).get;
                return get();
            },
            enumerable: false,
            configurable: true
        });
        return SdTokenService;
    }());
    SdTokenService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdTokenService_Factory() { return new SdTokenService(i0.ɵɵinject(API_CONFIG, 8), i0.ɵɵinject(i2.SdCacheService)); }, token: SdTokenService, providedIn: "root" });
    SdTokenService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    SdTokenService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [API_CONFIG,] }, { type: i0.Optional }] },
        { type: i2.SdCacheService }
    ]; };

    var SdHttpInterceptor = /** @class */ (function () {
        function SdHttpInterceptor(configuration, tokenService) {
            this.configuration = configuration;
            this.tokenService = tokenService;
        }
        SdHttpInterceptor.prototype.intercept = function (request, next) {
            var _this = this;
            var _a, _b, _c, _d;
            if (((_a = this.configuration) === null || _a === void 0 ? void 0 : _a.tokenHeader) && this.tokenService.token) {
                request = request.clone({ headers: request.headers.set(this.configuration.tokenHeader, this.tokenService.token) });
            }
            if (!request.url.startsWith('http')) {
                request = request.clone({
                    url: (((_b = this.configuration) === null || _b === void 0 ? void 0 : _b.host) || location.host) + request.url
                });
            }
            if (request.body instanceof FormData) {
                request = request.clone({
                    headers: request.headers.delete('Content-Type')
                });
            }
            var beforeRemote = (_d = (_c = this.configuration) === null || _c === void 0 ? void 0 : _c.beforeRemote) === null || _d === void 0 ? void 0 : _d.call(_c, request);
            if (beforeRemote instanceof Promise) {
                return rxjs.from(beforeRemote).pipe(operators.switchMap(function () { return next.handle(request); }), operators.map(function (event) {
                    var _a, _b;
                    if (event instanceof i1.HttpResponse) {
                        (_b = (_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.afterRemote) === null || _b === void 0 ? void 0 : _b.call(_a, event);
                    }
                    return event;
                }), operators.catchError(function (error) {
                    var _a, _b;
                    (_b = (_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.afterRemote) === null || _b === void 0 ? void 0 : _b.call(_a, error);
                    return rxjs.throwError(error);
                }));
            }
            return next.handle(request).pipe(operators.map(function (event) {
                var _a, _b;
                if (event instanceof i1.HttpResponse) {
                    (_b = (_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.afterRemote) === null || _b === void 0 ? void 0 : _b.call(_a, event);
                }
                return event;
            }), operators.catchError(function (error) {
                var _a, _b;
                (_b = (_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.afterRemote) === null || _b === void 0 ? void 0 : _b.call(_a, error);
                return rxjs.throwError(error);
            }));
        };
        return SdHttpInterceptor;
    }());
    SdHttpInterceptor.decorators = [
        { type: i0.Injectable }
    ];
    SdHttpInterceptor.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [API_CONFIG,] }, { type: i0.Optional }] },
        { type: SdTokenService }
    ]; };

    var SdApiModule = /** @class */ (function () {
        function SdApiModule() {
        }
        return SdApiModule;
    }());
    SdApiModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [
                        i1.HttpClientModule,
                    ],
                    exports: [
                        i1.HttpClientModule
                    ],
                    providers: [
                        { provide: i1.HTTP_INTERCEPTORS, useClass: SdHttpInterceptor, multi: true }
                    ],
                },] }
    ];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _timeout, _cacheDuration, _cache, _defineParams;
    var SdApiService = /** @class */ (function () {
        function SdApiService(httpClient, configuration, cacheService, tokenService) {
            var _this = this;
            this.httpClient = httpClient;
            this.configuration = configuration;
            this.cacheService = cacheService;
            this.tokenService = tokenService;
            this.uploadId = 'U118fefb1-3085-4641-8cb8-f7fe5c28f509';
            _timeout.set(this, 120000); // 120s
            _cacheDuration.set(this, 2000); // 2s
            _cache.set(this, {});
            this.translate = function (value) {
                var _a;
                return ((_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.translate(value)) || value;
            };
            this.post = function (url, body, headers, options) { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, hashKey, apiTimeout;
                var _this = this;
                return __generator(this, function (_e) {
                    url = (options === null || options === void 0 ? void 0 : options.encodeURI) === false ? url : encodeURI(url);
                    headers =
                        headers ||
                            this.tokenService.customHeaders({
                                url: url,
                            });
                    hashKey = uuid.v4();
                    if (!(body instanceof FormData)) {
                        hashKey = hash__default['default']({
                            url: url,
                            headers: headers,
                            body: body,
                        });
                    }
                    apiTimeout = (options === null || options === void 0 ? void 0 : options.timeout) || __classPrivateFieldGet(this, _timeout);
                    if (!__classPrivateFieldGet(this, _cache)[hashKey] || Date.addMiliseconds(__classPrivateFieldGet(this, _cache)[hashKey].createdDate, __classPrivateFieldGet(this, _cacheDuration)) < new Date()) {
                        __classPrivateFieldGet(this, _cache)[hashKey] = {
                            createdDate: new Date(),
                            subject: new rxjs.Subject(),
                        };
                        if ((options === null || options === void 0 ? void 0 : options.responseType) && options.responseType !== 'json') {
                            this.httpClient
                                .post(url, body, {
                                observe: 'body',
                                headers: headers,
                                responseType: options === null || options === void 0 ? void 0 : options.responseType,
                            })
                                .pipe(operators.timeout(apiTimeout))
                                .subscribe(function (res) {
                                __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                    status: 'success',
                                    result: res,
                                };
                                __classPrivateFieldGet(_this, _cache)[hashKey].subject.next(res);
                            }, function (err) {
                                __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                    status: 'error',
                                    result: err,
                                };
                                __classPrivateFieldGet(_this, _cache)[hashKey].subject.error(err);
                            });
                        }
                        else {
                            this.httpClient
                                .post(url, body, {
                                observe: 'response',
                                headers: headers,
                            })
                                .pipe(operators.timeout(apiTimeout))
                                .subscribe(function (res) {
                                if (res.ok) {
                                    __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                        status: 'success',
                                        result: res.body,
                                    };
                                    __classPrivateFieldGet(_this, _cache)[hashKey].subject.next(res.body);
                                }
                                else {
                                    __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                        status: 'error',
                                        result: res.body,
                                    };
                                    __classPrivateFieldGet(_this, _cache)[hashKey].subject.error(res.body);
                                }
                            }, function (err) {
                                __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                    status: 'error',
                                    result: err,
                                };
                                __classPrivateFieldGet(_this, _cache)[hashKey].subject.error(err);
                            });
                        }
                    }
                    if ((_a = __classPrivateFieldGet(this, _cache)[hashKey].response) === null || _a === void 0 ? void 0 : _a.status) {
                        if (((_b = __classPrivateFieldGet(this, _cache)[hashKey].response) === null || _b === void 0 ? void 0 : _b.status) === 'success') {
                            return [2 /*return*/, __classPrivateFieldGet(this, _cache)[hashKey].response.result];
                        }
                        throw __classPrivateFieldGet(this, _cache)[hashKey].response.result;
                    }
                    return [2 /*return*/, __classPrivateFieldGet(this, _cache)[hashKey].subject.pipe(operators.take(1)).toPromise()];
                });
            }); };
            this.postCache = function (url, body, options) { return __awaiter(_this, void 0, void 0, function () {
                var headers, _e, get, set, has, result;
                return __generator(this, function (_f) {
                    switch (_f.label) {
                        case 0:
                            headers = (options === null || options === void 0 ? void 0 : options.headers) ||
                                this.tokenService.customHeaders({
                                    url: url,
                                });
                            _e = this.cacheService.create({
                                url: url,
                                headers: headers,
                                body: body,
                            }, {
                                type: options === null || options === void 0 ? void 0 : options.cacheType,
                                hours: options === null || options === void 0 ? void 0 : options.cacheHours,
                            }), get = _e.get, set = _e.set, has = _e.has;
                            if (!!has()) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.post(url, body, options === null || options === void 0 ? void 0 : options.headers, {
                                    timeout: 5000,
                                })];
                        case 1:
                            result = _f.sent();
                            set(result);
                            return [2 /*return*/, result];
                        case 2: return [2 /*return*/, get()];
                    }
                });
            }); };
            this.put = function (url, body, headers) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            headers =
                                headers ||
                                    this.tokenService.customHeaders({
                                        url: url,
                                    });
                            return [4 /*yield*/, new Promise(function (resolve, reject) {
                                    _this.httpClient
                                        .put(encodeURI(url), body, {
                                        observe: 'response',
                                        headers: headers,
                                    })
                                        .pipe(operators.timeout(__classPrivateFieldGet(_this, _timeout)))
                                        .toPromise()
                                        .then(function (result) {
                                        if (result.ok) {
                                            resolve(result.body);
                                        }
                                        else {
                                            reject(result.body);
                                        }
                                    })
                                        .catch(function (httpErrorResponse) {
                                        reject(httpErrorResponse);
                                    });
                                })];
                        case 1: return [2 /*return*/, _e.sent()];
                    }
                });
            }); };
            this.patch = function (url, body, headers) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            headers =
                                headers ||
                                    this.tokenService.customHeaders({
                                        url: url,
                                    });
                            return [4 /*yield*/, new Promise(function (resolve, reject) {
                                    _this.httpClient
                                        .patch(encodeURI(url), body, {
                                        observe: 'response',
                                        headers: headers,
                                    })
                                        .pipe(operators.timeout(__classPrivateFieldGet(_this, _timeout)))
                                        .toPromise()
                                        .then(function (result) {
                                        if (result.ok) {
                                            resolve(result.body);
                                        }
                                        else {
                                            reject(result.body);
                                        }
                                    })
                                        .catch(function (httpErrorResponse) {
                                        reject(httpErrorResponse);
                                    });
                                })];
                        case 1: return [2 /*return*/, _e.sent()];
                    }
                });
            }); };
            _defineParams.set(this, function (request) {
                var e_1, _e;
                var rq = [];
                try {
                    for (var _f = __values(Object.entries(request)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var _h = __read(_g.value, 2), key = _h[0], value = _h[1];
                        if (value !== null && value !== undefined && value !== '' && (value === null || value === void 0 ? void 0 : value.toString()) !== '') {
                            rq.push(encodeURIComponent(key) + "=" + encodeURIComponent(value));
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_e = _f.return)) _e.call(_f);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return "?" + (rq === null || rq === void 0 ? void 0 : rq.join('&'));
            });
            this.getWithParams = function (url, params, options) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0: return [4 /*yield*/, this.get("" + url + __classPrivateFieldGet(this, _defineParams).call(this, params), options === null || options === void 0 ? void 0 : options.headers, Object.assign(Object.assign({}, options), { encodeURI: false }))];
                        case 1: return [2 /*return*/, _e.sent()];
                    }
                });
            }); };
            this.getCacheWithParams = function (url, params, headers, options) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0: return [4 /*yield*/, this.getCache("" + url + __classPrivateFieldGet(this, _defineParams).call(this, params), Object.assign(Object.assign({}, options), { headers: headers, encodeURI: false }))];
                        case 1: return [2 /*return*/, _e.sent()];
                    }
                });
            }); };
            this.get = function (url, headers, options) { return __awaiter(_this, void 0, void 0, function () {
                var _c, _d, encodedUrl, hashKey, apiTimeout;
                var _this = this;
                return __generator(this, function (_e) {
                    headers =
                        headers ||
                            this.tokenService.customHeaders({
                                url: url,
                            });
                    encodedUrl = (options === null || options === void 0 ? void 0 : options.encodeURI) === false ? url : encodeURI(url);
                    hashKey = hash__default['default']({
                        encodedUrl: encodedUrl,
                        headers: headers,
                    });
                    apiTimeout = (options === null || options === void 0 ? void 0 : options.timeout) || __classPrivateFieldGet(this, _timeout);
                    if (!__classPrivateFieldGet(this, _cache)[hashKey] || Date.addMiliseconds(__classPrivateFieldGet(this, _cache)[hashKey].createdDate, __classPrivateFieldGet(this, _cacheDuration)) < new Date()) {
                        __classPrivateFieldGet(this, _cache)[hashKey] = {
                            createdDate: new Date(),
                            subject: new rxjs.Subject(),
                        };
                        if ((options === null || options === void 0 ? void 0 : options.responseType) && options.responseType !== 'json') {
                            this.httpClient
                                .get(encodedUrl, { observe: 'body', headers: headers, responseType: options === null || options === void 0 ? void 0 : options.responseType })
                                .pipe(operators.timeout(apiTimeout))
                                .subscribe(function (res) {
                                __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                    status: 'success',
                                    result: res,
                                };
                                __classPrivateFieldGet(_this, _cache)[hashKey].subject.next(res);
                            }, function (err) {
                                __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                    status: 'error',
                                    result: err,
                                };
                                __classPrivateFieldGet(_this, _cache)[hashKey].subject.error(err);
                            });
                        }
                        else {
                            this.httpClient
                                .get(encodedUrl, { observe: 'response', headers: headers })
                                .pipe(operators.timeout(apiTimeout))
                                .subscribe(function (res) {
                                if (res.ok) {
                                    __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                        status: 'success',
                                        result: res.body,
                                    };
                                    __classPrivateFieldGet(_this, _cache)[hashKey].subject.next(res.body);
                                }
                                else {
                                    __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                        status: 'error',
                                        result: res.body,
                                    };
                                    __classPrivateFieldGet(_this, _cache)[hashKey].subject.error(res.body);
                                }
                            }, function (err) {
                                __classPrivateFieldGet(_this, _cache)[hashKey].response = {
                                    status: 'error',
                                    result: err,
                                };
                                __classPrivateFieldGet(_this, _cache)[hashKey].subject.error(err);
                            });
                        }
                    }
                    if ((_c = __classPrivateFieldGet(this, _cache)[hashKey].response) === null || _c === void 0 ? void 0 : _c.status) {
                        if (((_d = __classPrivateFieldGet(this, _cache)[hashKey].response) === null || _d === void 0 ? void 0 : _d.status) === 'success') {
                            return [2 /*return*/, __classPrivateFieldGet(this, _cache)[hashKey].response.result];
                        }
                        throw __classPrivateFieldGet(this, _cache)[hashKey].response.result;
                    }
                    return [2 /*return*/, __classPrivateFieldGet(this, _cache)[hashKey].subject.pipe(operators.take(1)).toPromise()];
                });
            }); };
            this.getCache = function (url, options) { return __awaiter(_this, void 0, void 0, function () {
                var headers, encodedUrl, _e, get, set, has, result;
                return __generator(this, function (_f) {
                    switch (_f.label) {
                        case 0:
                            headers = (options === null || options === void 0 ? void 0 : options.headers) ||
                                this.tokenService.customHeaders({
                                    url: url,
                                });
                            encodedUrl = (options === null || options === void 0 ? void 0 : options.encodeURI) === false ? url : encodeURI(url);
                            _e = this.cacheService.create({
                                encodedUrl: encodedUrl,
                                headers: headers,
                            }, {
                                type: options === null || options === void 0 ? void 0 : options.cacheType,
                                hours: options === null || options === void 0 ? void 0 : options.cacheHours,
                            }), get = _e.get, set = _e.set, has = _e.has;
                            if (!(!has() || (options === null || options === void 0 ? void 0 : options.reload))) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.get(encodedUrl, options === null || options === void 0 ? void 0 : options.headers, { encodeURI: false, timeout: 5000 })];
                        case 1:
                            result = _f.sent();
                            set(result);
                            return [2 /*return*/, result];
                        case 2: return [2 /*return*/, get()];
                    }
                });
            }); };
            this.delete = function (url, headers) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            headers =
                                headers ||
                                    this.tokenService.customHeaders({
                                        url: url,
                                    });
                            return [4 /*yield*/, new Promise(function (resolve, reject) {
                                    _this.httpClient
                                        .delete(encodeURI(url), { observe: 'response', headers: headers })
                                        .pipe(operators.timeout(__classPrivateFieldGet(_this, _timeout)))
                                        .toPromise()
                                        .then(function (result) {
                                        if (result.ok) {
                                            resolve(result.body);
                                        }
                                        else {
                                            reject(result.body);
                                        }
                                    })
                                        .catch(function (httpErrorResponse) {
                                        reject(httpErrorResponse);
                                    });
                                })];
                        case 1: return [2 /*return*/, _e.sent()];
                    }
                });
            }); };
            this.uploadSingle = function (url, option) {
                return SdUtility.upload(option).then(function (file) { return _this.upload(url, file); });
            };
            this.upload = function (url, file) { return __awaiter(_this, void 0, void 0, function () {
                var lastDot, message, formData;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            lastDot = file.name.lastIndexOf('.');
                            if (lastDot === -1) {
                                message = this.translate("Invalid file extension");
                                throw new Error(message);
                            }
                            formData = new FormData();
                            formData.append('file', file, file.name);
                            return [4 /*yield*/, this.post(url, formData)];
                        case 1: return [2 /*return*/, _e.sent()];
                    }
                });
            }); };
        }
        Object.defineProperty(SdApiService.prototype, "http", {
            get: function () {
                return this.httpClient;
            },
            enumerable: false,
            configurable: true
        });
        return SdApiService;
    }());
    _timeout = new WeakMap(), _cacheDuration = new WeakMap(), _cache = new WeakMap(), _defineParams = new WeakMap();
    SdApiService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdApiService_Factory() { return new SdApiService(i0.ɵɵinject(i1.HttpClient), i0.ɵɵinject(API_CONFIG, 8), i0.ɵɵinject(i2.SdCacheService), i0.ɵɵinject(SdTokenService)); }, token: SdApiService, providedIn: "root" });
    SdApiService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    SdApiService.ctorParameters = function () { return [
        { type: i1.HttpClient },
        { type: undefined, decorators: [{ type: i0.Inject, args: [API_CONFIG,] }, { type: i0.Optional }] },
        { type: i2.SdCacheService },
        { type: SdTokenService }
    ]; };

    var SdHttpService = /** @class */ (function () {
        function SdHttpService(httpClient, tokenService) {
            var _this = this;
            this.httpClient = httpClient;
            this.tokenService = tokenService;
            this.get = function (url, option) {
                option = Object.assign(Object.assign({}, option), { headers: option.headers || _this.tokenService.customHeaders({
                        url: url
                    }) });
                return _this.httpClient.get(url, option);
            };
            this.post = function (url, body, option) {
                option = Object.assign(Object.assign({}, option), { headers: option.headers || _this.tokenService.customHeaders({
                        url: url
                    }) });
                return _this.httpClient.post(url, body, option);
            };
            this.put = function (url, body, option) {
                option = Object.assign(Object.assign({}, option), { headers: option.headers || _this.tokenService.customHeaders({
                        url: url
                    }) });
                return _this.httpClient.put(url, body, option);
            };
            this.delete = function (url, option) {
                option = Object.assign(Object.assign({}, option), { headers: option.headers || _this.tokenService.customHeaders({
                        url: url
                    }) });
                return _this.httpClient.delete(url, option);
            };
            this.request = function (method, url, option) {
                option = Object.assign(Object.assign({}, option), { headers: option.headers || _this.tokenService.customHeaders({
                        url: url
                    }) });
                return _this.httpClient.request(method, url, option);
            };
        }
        return SdHttpService;
    }());
    SdHttpService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdHttpService_Factory() { return new SdHttpService(i0.ɵɵinject(i1.HttpClient), i0.ɵɵinject(SdTokenService)); }, token: SdHttpService, providedIn: "root" });
    SdHttpService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    SdHttpService.ctorParameters = function () { return [
        { type: i1.HttpClient },
        { type: SdTokenService }
    ]; };

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.API_CONFIG = API_CONFIG;
    exports.SdApiModule = SdApiModule;
    exports.SdApiService = SdApiService;
    exports.SdHttpInterceptor = SdHttpInterceptor;
    exports.SdHttpService = SdHttpService;
    exports.SdTokenService = SdTokenService;
    exports.TOKEN = TOKEN;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-api.umd.js.map
