(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@sd-angular/core/common'), require('@angular/core'), require('@angular/common'), require('ngx-device-detector'), require('@angular/platform-browser'), require('rxjs'), require('rxjs/operators'), require('md5'), require('uuid')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/utility', ['exports', '@sd-angular/core/common', '@angular/core', '@angular/common', 'ngx-device-detector', '@angular/platform-browser', 'rxjs', 'rxjs/operators', 'md5', 'uuid'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.utility = {}), global['sd-angular'].core.common, global.ng.core, global.ng.common, global['ngx-device-detector'], global.ng.platformBrowser, global.rxjs, global.rxjs.operators, global.md5, global.uuid));
}(this, (function (exports, common$1, i0, common, ngxDeviceDetector, platformBrowser, rxjs, operators, md5, uuid) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var md5__default = /*#__PURE__*/_interopDefaultLegacy(md5);

    var SdDesktopDirective = /** @class */ (function () {
        function SdDesktopDirective(templateRef, viewContainerRef, deviceService) {
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            if (deviceService.isDesktop()) {
                this.viewContainerRef.createEmbeddedView(this.templateRef);
            }
        }
        return SdDesktopDirective;
    }());
    SdDesktopDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[sdDesktop]'
                },] }
    ];
    SdDesktopDirective.ctorParameters = function () { return [
        { type: i0.TemplateRef },
        { type: i0.ViewContainerRef },
        { type: ngxDeviceDetector.DeviceDetectorService }
    ]; };

    var SdMobileDirective = /** @class */ (function () {
        function SdMobileDirective(templateRef, viewContainerRef, deviceService) {
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            if (deviceService.isMobile()) {
                this.viewContainerRef.createEmbeddedView(this.templateRef);
            }
        }
        return SdMobileDirective;
    }());
    SdMobileDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[sdMobile]'
                },] }
    ];
    SdMobileDirective.ctorParameters = function () { return [
        { type: i0.TemplateRef },
        { type: i0.ViewContainerRef },
        { type: ngxDeviceDetector.DeviceDetectorService }
    ]; };

    var SdMobileTabletDirective = /** @class */ (function () {
        function SdMobileTabletDirective(templateRef, viewContainerRef, deviceService) {
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            if (deviceService.isMobile() || deviceService.isTablet()) {
                this.viewContainerRef.createEmbeddedView(this.templateRef);
            }
        }
        return SdMobileTabletDirective;
    }());
    SdMobileTabletDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[sdMobileTablet]'
                },] }
    ];
    SdMobileTabletDirective.ctorParameters = function () { return [
        { type: i0.TemplateRef },
        { type: i0.ViewContainerRef },
        { type: ngxDeviceDetector.DeviceDetectorService }
    ]; };

    var SdTabletDirective = /** @class */ (function () {
        function SdTabletDirective(templateRef, viewContainerRef, deviceService) {
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            if (deviceService.isTablet()) {
                this.viewContainerRef.createEmbeddedView(this.templateRef);
            }
        }
        return SdTabletDirective;
    }());
    SdTabletDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[sdTablet]'
                },] }
    ];
    SdTabletDirective.ctorParameters = function () { return [
        { type: i0.TemplateRef },
        { type: i0.ViewContainerRef },
        { type: ngxDeviceDetector.DeviceDetectorService }
    ]; };

    var SdCurrencyPipe = /** @class */ (function () {
        function SdCurrencyPipe() {
        }
        SdCurrencyPipe.prototype.transform = function (value, digits) {
            return Number.toVNCurrency(value, digits);
        };
        return SdCurrencyPipe;
    }());
    SdCurrencyPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'sdCurrency',
                },] }
    ];

    var SdSafeHtmlPipe = /** @class */ (function () {
        function SdSafeHtmlPipe(sanitizer) {
            this.sanitizer = sanitizer;
        }
        SdSafeHtmlPipe.prototype.transform = function (html) {
            if (!html) {
                return undefined;
            }
            return this.sanitizer.bypassSecurityTrustHtml(html);
        };
        return SdSafeHtmlPipe;
    }());
    SdSafeHtmlPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'safeHtml',
                },] }
    ];
    SdSafeHtmlPipe.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer }
    ]; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _translate;
    var SdUtilityService = /** @class */ (function () {
        function SdUtilityService() {
            var _this = this;
            _translate.set(this, function (value) { return value; });
            this.hashMD5 = function (key) { return md5__default['default'](key); };
            this.arrayToObject = function (items, key) {
                return items.reduce(function (obj, item) { obj[item[key]] = item; return obj; }, {});
            };
            this.changeAliasLowerCase = function (alias) {
                var _a;
                var str = (_a = alias === null || alias === void 0 ? void 0 : alias.toString()) !== null && _a !== void 0 ? _a : '';
                str = str.toString().toLowerCase();
                str = str.replace(/à|á|ạ|ả|ã|â|ầ|ấ|ậ|ẩ|ẫ|ă|ằ|ắ|ặ|ẳ|ẵ/g, 'a');
                str = str.replace(/è|é|ẹ|ẻ|ẽ|ê|ề|ế|ệ|ể|ễ/g, 'e');
                str = str.replace(/ì|í|ị|ỉ|ĩ/g, 'i');
                str = str.replace(/ò|ó|ọ|ỏ|õ|ô|ồ|ố|ộ|ổ|ỗ|ơ|ờ|ớ|ợ|ở|ỡ/g, 'o');
                str = str.replace(/ù|ú|ụ|ủ|ũ|ư|ừ|ứ|ự|ử|ữ/g, 'u');
                str = str.replace(/ỳ|ý|ỵ|ỷ|ỹ/g, 'y');
                str = str.replace(/đ/g, 'd');
                str = str.replace(/!|@|%|\^|\*|\(|\)|\+|\=|\<|\>|\?|\/|,|\.|\:|\;|\'|\"|\&|\#|\[|\]|~|\$|_|`|-|{|}|\||\\/g, ' ');
                str = str.replace(/ + /g, ' ');
                str = str.trim();
                return str;
            };
            this.timeDifference = function (previous, current) {
                if (current === void 0) { current = new Date(); }
                if (!Date.isDate(previous)) {
                    return '';
                }
                if (!Date.isDate(current)) {
                    return '';
                }
                var from = new Date(previous);
                var to = new Date(current);
                var msPerMinute = 60 * 1000;
                var msPerHour = msPerMinute * 60;
                var msPerDay = msPerHour * 24;
                var msPerMonth = msPerDay * 30;
                var msPerYear = msPerDay * 365;
                var elapsed = to.getTime() - from.getTime();
                if (elapsed < msPerMinute) {
                    return Math.round(elapsed / 1000) + " " + __classPrivateFieldGet(_this, _translate).call(_this, 'seconds ago');
                }
                if (elapsed < msPerHour) {
                    return Math.round(elapsed / msPerMinute) + " " + __classPrivateFieldGet(_this, _translate).call(_this, 'minutes ago');
                }
                if (elapsed < msPerDay) {
                    return Math.round(elapsed / msPerHour) + " " + __classPrivateFieldGet(_this, _translate).call(_this, 'hours ago');
                }
                if (elapsed < msPerMonth) {
                    return Math.round(elapsed / msPerDay) + " " + __classPrivateFieldGet(_this, _translate).call(_this, 'days ago');
                }
                if (elapsed < msPerYear) {
                    return Math.round(elapsed / msPerMonth) + " " + __classPrivateFieldGet(_this, _translate).call(_this, 'months ago');
                }
                return Math.round(elapsed / msPerYear) + " " + __classPrivateFieldGet(_this, _translate).call(_this, 'years ago');
            };
            this.upload = function (option) {
                return SdUtility.upload(option);
            };
            this.download = function (filePath, fileName) {
                var link = document.createElement('a');
                link.download = "" + (fileName || uuid.v4());
                link.href = filePath;
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            };
            this.copyToClipboard = function (text) {
                navigator.clipboard.writeText(text);
            };
            this.printHtml = function (elementId, fileName) {
                var printId = "sdPrintSection";
                var div = 'sd-print';
                var elem = document.getElementById(elementId).firstElementChild;
                var domClone = elem.cloneNode(true);
                var printSection = document.createElement('div');
                printSection.id = printId;
                printSection.appendChild(domClone);
                document.body.insertBefore(printSection, document.body.firstChild);
                document.querySelector('body app-root').classList.add(div);
                var title = document.title;
                if (fileName) {
                    document.title = fileName;
                }
                window.print();
                document.title = title;
                document.querySelector('body app-root').classList.remove(div);
                var oldElem = document.getElementById(printId);
                if (oldElem !== null) {
                    oldElem.parentNode.removeChild(oldElem); // oldElem.remove() not supported by IE
                }
            };
            this.allWithPaging = function (func, defaultPageSize) { return __awaiter(_this, void 0, void 0, function () {
                var _a, pageSize, pageNumber, count, items, res;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            pageSize = defaultPageSize || 1000;
                            pageNumber = 0;
                            count = 0;
                            items = [];
                            _b.label = 1;
                        case 1:
                            if (!true) return [3 /*break*/, 3];
                            return [4 /*yield*/, func(pageSize, pageNumber)];
                        case 2:
                            res = _b.sent();
                            if (Array(res === null || res === void 0 ? void 0 : res.items) && (res === null || res === void 0 ? void 0 : res.total) > 0) {
                                items = __spread(items, res.items);
                                count += res.items.length;
                                pageNumber++;
                                if (count >= res.total || !((_a = res.items) === null || _a === void 0 ? void 0 : _a.length)) {
                                    return [2 /*return*/, items];
                                }
                            }
                            else {
                                return [2 /*return*/, []];
                            }
                            return [3 /*break*/, 1];
                        case 3: return [2 /*return*/];
                    }
                });
            }); };
        }
        return SdUtilityService;
    }());
    _translate = new WeakMap();
    SdUtilityService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdUtilityService_Factory() { return new SdUtilityService(); }, token: SdUtilityService, providedIn: "root" });
    SdUtilityService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    SdUtilityService.ctorParameters = function () { return []; };

    var SdTimeDifferentPipe = /** @class */ (function () {
        function SdTimeDifferentPipe(utilityService) {
            this.utilityService = utilityService;
            this.maxSecond = 60;
            this.maxMinute = this.maxSecond * 60;
            this.maxHour = this.maxMinute * 24;
            this.maxDay = this.maxHour * 30;
            this.maxMonth = this.maxHour * 365;
        }
        SdTimeDifferentPipe.prototype.transform = function (value, format, different) {
            var _this = this;
            if (!Date.isDate(value)) {
                return rxjs.of(null);
            }
            if (!different) {
                return rxjs.of(Date.toFormat(value, format));
            }
            if (Math.round((new Date().getTime() - new Date(value).getTime()) / 1000) < 0) {
                return rxjs.of(Date.toFormat(value, format));
            }
            return rxjs.interval(1000).pipe(operators.map(function () {
                var timeDifferent = Math.round((new Date().getTime() - new Date(value).getTime()) / 1000);
                if (different === 'month' && timeDifferent < _this.maxMonth) {
                    return _this.utilityService.timeDifference(value);
                }
                if (different === 'day' && timeDifferent < _this.maxDay) {
                    return _this.utilityService.timeDifference(value);
                }
                if (different === 'hour' && timeDifferent < _this.maxHour) {
                    return _this.utilityService.timeDifference(value);
                }
                if (different === 'minute' && timeDifferent < _this.maxMinute) {
                    return _this.utilityService.timeDifference(value);
                }
                if (different === 'second' && timeDifferent < _this.maxSecond) {
                    return _this.utilityService.timeDifference(value);
                }
                return Date.toFormat(value, format);
            }));
        };
        return SdTimeDifferentPipe;
    }());
    SdTimeDifferentPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'sdTimeDifferent',
                },] }
    ];
    SdTimeDifferentPipe.ctorParameters = function () { return [
        { type: SdUtilityService }
    ]; };

    var SdUtilityModule = /** @class */ (function () {
        function SdUtilityModule() {
        }
        return SdUtilityModule;
    }());
    SdUtilityModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                    ],
                    declarations: [
                        SdDesktopDirective,
                        SdMobileTabletDirective,
                        SdMobileDirective,
                        SdTabletDirective,
                        SdCurrencyPipe,
                        SdSafeHtmlPipe,
                        SdTimeDifferentPipe
                    ],
                    exports: [
                        SdDesktopDirective,
                        SdMobileTabletDirective,
                        SdMobileDirective,
                        SdTabletDirective,
                        SdCurrencyPipe,
                        SdSafeHtmlPipe,
                        SdTimeDifferentPipe
                    ],
                    providers: [
                        SdCurrencyPipe,
                        SdSafeHtmlPipe,
                        SdTimeDifferentPipe
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdCurrencyPipe = SdCurrencyPipe;
    exports.SdDesktopDirective = SdDesktopDirective;
    exports.SdMobileDirective = SdMobileDirective;
    exports.SdMobileTabletDirective = SdMobileTabletDirective;
    exports.SdSafeHtmlPipe = SdSafeHtmlPipe;
    exports.SdTabletDirective = SdTabletDirective;
    exports.SdTimeDifferentPipe = SdTimeDifferentPipe;
    exports.SdUtilityModule = SdUtilityModule;
    exports.SdUtilityService = SdUtilityService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-utility.umd.js.map
