export interface SdCommentOption {
    items: () => Comment[] | Promise<Comment[]>;
    event: {
        onSend: (text: string) => Promise<void>;
    };
    editor?: {
        enabled?: boolean;
        toolbar?: any;
        styles?: any;
        mentionValues?: {
            id: string;
            value: string;
            link?: string;
        }[];
        hashTagValues?: {
            id: string;
            value: string;
            link?: string;
        }[];
        args?: any;
    };
    style: 'basic' | 'style1';
    fullComment?: {
        enabled?: boolean;
        enableSendButton?: boolean;
        closeClickOutSide?: boolean;
    };
    autoReload?: {
        enabledButton?: boolean;
        timerMs?: number;
    };
}
export interface Comment extends BaseComment {
    children: CommentLv2[];
}
interface BaseComment {
    creator: string;
    email: string;
    createdDate: string | Date;
    content: string;
    picture: string;
}
interface CommentLv2 extends BaseComment {
    children: CommentLv3[];
}
interface CommentLv3 extends BaseComment {
}
export {};
