import { InjectionToken } from '@angular/core';
import Quill from 'quill';
export interface SdEditorAction {
    key: string;
    icon: string;
    tooltip: string;
    click: (event: any, args: SdEditorActionArgs) => void | Promise<void>;
}
export interface SdEditorActionArgs {
    qlKey: string;
    element: HTMLElement;
    loadingId: string;
    quill: Quill;
    cursorPosition: {
        index: number;
        length: number;
    };
    args?: any;
}
export interface IEditorConfiguration {
    uploadImage?: (formData: FormData, args?: any) => Promise<string>;
    actions?: SdEditorAction[];
}
export declare const EDITOR_CONFIG: InjectionToken<IEditorConfiguration>;
