export * from './excel.model';
export interface SdExportTemplate {
    fileName?: string;
    columns: SdExportTemplateColumn[];
    sheets?: {
        name: string;
        items: any[];
        fields: string[];
    }[];
}
export interface SdExportColumn {
    field: string;
    title: string;
    description?: string;
    width?: string;
}
export interface SdExportTemplateColumn extends SdExportColumn {
    required?: boolean;
    color?: string;
    fontColor?: string;
    fill?: string;
}
export interface SdExportFile {
    fileName?: string;
    filePath?: string;
}
export interface SdExportSheet<T = any> {
    name: string;
    items: T[];
    fields: Extract<keyof T, string>[];
}
export interface SdExportOption<T = any> {
    columns: SdExportTemplateColumn[];
    items: T[];
    fileName?: string;
    sheets?: SdExportSheet[];
}
export declare type GroupPermission = 'view' | 'add' | 'delete';
export declare const API: {
    uploadTemplate: string;
    generateUploadTemplate: string;
    filesInFolder: string;
    removeFile: string;
    sdExportByTemplate: string;
    sdMergePDF: string;
};
