import { SdApiService } from '@sd-angular/core/api';
import { SdExportTemplate, SdExportOption, SdExportFile, SdExportCustomOption } from './export.model';
import { SdNotifyService } from '@sd-angular/core/notify';
import { IFirebaseConfiguration } from '@sd-angular/core/common';
export declare class SdExportService {
    #private;
    private apiService;
    private notifyService;
    private firebaseConfiguration;
    private get functionUrl();
    private get folder();
    private get userFolder();
    constructor(apiService: SdApiService, notifyService: SdNotifyService, firebaseConfiguration: IFirebaseConfiguration);
    generateTemplate: (template: SdExportTemplate) => Promise<void>;
    uploadTemplate: (args: {
        key: string;
        group?: string;
        validator?: (fileName: string) => string;
    }) => Promise<SdExportFile>;
    generateUploadTemplate: (args: {
        key: string;
        template: SdExportTemplate;
        group?: string;
    }) => Promise<{
        filePath: any;
        fileName: any;
    }>;
    removeFile: (args: {
        key: string;
        group?: string;
        fileName?: string;
    }) => Promise<void>;
    filesInFolder: (args: {
        key: string;
        group?: string;
    }) => Promise<SdExportFile[]>;
    download: (filePath: string, fileName?: string) => void;
    exportByTemplate: (args: {
        filePath: string;
        columns: any[];
        items: any[];
        fileName?: string;
    }) => Promise<void>;
    exportCSV: (option: SdExportOption) => Promise<void>;
    export: (option: SdExportOption) => Promise<void>;
    exportCustom: (option: SdExportCustomOption) => Promise<void>;
    mergePDF: (urls: string[]) => Promise<void>;
    uploadXlsx: () => Promise<{
        items: any[];
        file: File;
    } | undefined>;
    parseXlsx: (file: File) => Promise<{
        items: any[];
        file: File;
    }>;
}
