import { Component, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { MatIconModule } from '@angular/material/icon';
import { MatTooltipModule } from '@angular/material/tooltip';

class SdHeaderTitleComponent {
    constructor() { }
    ngOnInit() {
    }
}
SdHeaderTitleComponent.decorators = [
    { type: Component, args: [{
                selector: 'sd-header-title',
                template: "<div class=\"d-flex align-items-center\" style=\"width: 100%;\">\r\n  <div *ngIf=\"icon\" class=\"flex-shrink-1 c-header-icon\">\r\n    <mat-icon class=\"material-symbols-outlined text-grey\">{{icon}}</mat-icon>\r\n  </div>\r\n  <div class=\"d-flex flex-column w-100 overflow-hidden\">\r\n    <div class=\"d-flex\">\r\n      <span class=\"T16M\">{{title}}</span>\r\n      <ng-container *ngIf=\"tooltip\">\r\n        <mat-icon\r\n          [matTooltip]=\"tooltip\"\r\n          class=\"material-icons-outlined c-header-icon-tooltip\"> info </mat-icon>\r\n      </ng-container>\r\n    </div>\r\n    <span *ngIf=\"description\" class=\"c-header-description\">{{description}}</span>\r\n  </div>\r\n  <div class=\"flex-shrink-1\">\r\n    <ng-content select=\"[sdHeaderRight]\"></ng-content>\r\n  </div>\r\n</div>\r\n",
                styles: [":host{width:100%}:host .c-header-icon{align-items:center;display:flex;height:28px;margin-right:8px;width:28px}:host .c-header-icon-tooltip{align-items:center;color:#757575;display:flex;font-size:20px;height:28px!important;margin-left:10px}:host .c-header-description{font-size:14px;line-height:20px}"]
            },] }
];
SdHeaderTitleComponent.ctorParameters = () => [];
SdHeaderTitleComponent.propDecorators = {
    title: [{ type: Input }],
    icon: [{ type: Input }],
    description: [{ type: Input }],
    tooltip: [{ type: Input }]
};

class SdHeaderTitleModule {
}
SdHeaderTitleModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatIconModule,
                    MatTooltipModule
                ],
                declarations: [SdHeaderTitleComponent],
                exports: [SdHeaderTitleComponent]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { SdHeaderTitleModule, SdHeaderTitleComponent as ɵa };
//# sourceMappingURL=sd-angular-core-header-title.js.map
