import { Component, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

class SdQuickAction {
    constructor() {
        this.isOpened = false;
        this.open = () => {
            this.isOpened = true;
        };
        this.close = () => {
            this.isOpened = false;
        };
    }
}
SdQuickAction.decorators = [
    { type: Component, args: [{
                selector: 'sd-quick-action',
                template: "<div class=\"c-quick-action media align-items-center\" [ngClass]=\"{'active': isOpened}\">\r\n  <div class=\"media-body mr-16 text-grey\">\r\n    <ng-content select=\"[sdMessage]\"></ng-content>\r\n  </div>\r\n  <ng-content select=\"[sdAction]\"></ng-content>\r\n</div>",
                styles: [".c-quick-action{background-color:#fff;border-radius:4px;bottom:90px;box-shadow:0 .4px .8px rgba(0,0,0,.1),0 3px 6px rgba(0,0,0,.2);left:0;margin:auto;min-width:400px;opacity:0;pointer-events:none;position:fixed;right:0;transform:translate3d(0,100%,0);transition:all .2s ease-in-out;visibility:hidden;width:-webkit-max-content;width:-moz-max-content;width:max-content;z-index:99}.c-quick-action.active{opacity:1;pointer-events:all;transform:translateZ(0);visibility:visible}"]
            },] }
];
SdQuickAction.ctorParameters = () => [];
SdQuickAction.propDecorators = {
    isOpened: [{ type: Input }]
};

class SdQuickActionModule {
}
SdQuickActionModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    SdQuickAction
                ],
                imports: [
                    CommonModule
                ],
                exports: [
                    SdQuickAction
                ],
                providers: [],
            },] }
];

/*
 * Public API Surface of superdev-angular-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { SdQuickAction, SdQuickActionModule };
//# sourceMappingURL=sd-angular-core-quick-action.js.map
