export declare type SdGridMaterialAction<T = any> = SdGridMaterialActionNormal<T> | SdGridMaterialActionChildren<T>;
export interface SdGridMaterialActionNormal<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    tooltip?: string;
    title?: string;
    color?: 'primary' | 'accent' | 'warn' | 'info' | 'success' | 'warning' | 'danger' | 'secondary';
    type?: 'fill' | 'light' | 'outline' | 'link';
    hidden?: boolean | ((rowData?: T) => boolean);
    isGrouped?: boolean;
    click: (selectedItems?: T[]) => void;
}
interface SdGridMaterialActionChildren<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    tooltip?: string;
    title?: string;
    color?: 'primary' | 'accent' | 'warn' | 'info' | 'success' | 'warning' | 'danger' | 'secondary';
    type?: 'fill' | 'light' | 'outline' | 'link';
    isGrouped?: boolean;
    children: SdGridMaterialActionNormal<T>[];
}
export declare type SdGridMaterialActionSimple<T = any> = SdGridMaterialActionSimpleNormal<T> | SdGridMaterialActionSimpleChildren<T>;
interface SdGridMaterialActionSimpleNormal<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    tooltip?: string;
    title?: string;
    color?: 'primary' | 'accent' | 'warn' | 'info' | 'success' | 'warning' | 'danger' | 'secondary';
    type?: 'fill' | 'light' | 'outline' | 'link';
    click: (selectedItems?: T[]) => void;
}
interface SdGridMaterialActionSimpleChildren<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    tooltip?: string;
    title?: string;
    color?: 'primary' | 'accent' | 'warn' | 'info' | 'success' | 'warning' | 'danger' | 'secondary';
    type?: 'fill' | 'light' | 'outline' | 'link';
    children: SdGridMaterialActionSimpleNormal<T>[];
}
export {};
