import { OnInit, AfterViewInit, EventEmitter } from '@angular/core';
import { SdGridColumn, SdGridExternalFilter } from '../../grid.model';
import { SdNotifyService } from '@sd-angular/core/notify';
import { SdTranslateService } from '@sd-angular/core/translate';
import { DeviceDetectorService } from 'ngx-device-detector';
import { QuickFilter } from '../grid-popup-filter/grid-popup-filter.model';
import { SdModal } from '@sd-angular/core/modal';
export declare class SdGridPopupQuickFilterDetail implements OnInit, AfterViewInit {
    private notifyService;
    private translateService;
    displayKey: string;
    isMobileOrTablet: boolean;
    modal: SdModal;
    quickFilters: QuickFilter[];
    accept: EventEmitter<any>;
    fields: Field[];
    selectableFields: Field[];
    columns: SdGridColumn[];
    externalFilters: SdGridExternalFilter[];
    filter: Filter;
    externalFilter: Filter;
    selectedField: {
        [key: string]: boolean;
    };
    page: 1 | 2;
    code: string;
    constructor(deviceService: DeviceDetectorService, notifyService: SdNotifyService, translateService: SdTranslateService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    open(columns: SdGridColumn[], externalFilters: SdGridExternalFilter[], filter?: Filter, externalFilter?: Filter, code?: string): void;
    onAccept: () => void;
    onCancel: () => void;
    onSelectField: (values: string[]) => void;
    onSelectFields: () => void;
}
interface Field {
    id: string;
    group: 'column' | 'external';
    type: string;
    code: string;
    title?: string;
    fromTitle?: string;
    toTitle?: string;
    [key: string]: any;
}
interface Filter {
    [field: string]: any;
}
export {};
