import '@sd-angular/core/common';
import { MatDialog } from '@angular/material/dialog';
import { ToastrService } from 'ngx-toastr';
import { SdTranslateService } from '@sd-angular/core/translate';
import { SdBadgeColor } from '@sd-angular/core/badge';
import { INotifyConfiguration } from './configurations/notify.configuration';
export declare class SdNotifyService {
    #private;
    private dialog;
    private toastr;
    private translateService;
    private configuration;
    constructor(dialog: MatDialog, toastr: ToastrService, translateService: SdTranslateService, configuration: INotifyConfiguration);
    alert: {
        info: (message?: string, title?: string, yesTitle?: string, icon?: string) => void;
        success: (message?: string, title?: string, yesTitle?: string, icon?: string) => void;
        warning: (message?: string, title?: string, yesTitle?: string, icon?: string) => void;
        error: (message?: string, title?: string, yesTitle?: string, icon?: string) => void;
    };
    notify: {
        success: (message?: string, delay?: number, title?: string) => void;
        warning: (message?: string | string[], delay?: number, title?: string) => void;
        error: (message?: string | string[], delay?: number, title?: string) => void;
    };
    handle: {
        error: (err: any) => void;
    };
    confirm: (message: string, option?: {
        title?: string;
        yesTitle?: string;
        noTitle?: string;
        yesButtonColor?: SdBadgeColor;
        noButtonColor?: SdBadgeColor;
    }) => Promise<unknown>;
    confirmDelete: () => Promise<unknown>;
    confirmApprove: () => Promise<unknown>;
    confirmWithInput: (title: string, option?: {
        message?: string;
        yesTitle?: string;
        noTitle?: string;
        required?: boolean;
        maxlength?: number;
        yesButtonColor?: SdBadgeColor;
        noButtonColor?: SdBadgeColor;
        defaultValue?: string;
    }) => Promise<string>;
    private translate;
}
