import { OnInit, AfterViewInit, EventEmitter, ChangeDetectorRef } from '@angular/core';
import { SdNotifyService } from '@sd-angular/core/notify';
import { SdLoadingService } from '@sd-angular/core/loading';
import { SdTranslateService } from '@sd-angular/core/translate';
import { MatSelectionList } from '@angular/material/list';
import { SdModal } from '@sd-angular/core/modal';
import { SdExportFile, SdExportService, SdExportColumn } from '@sd-angular/core/export';
import { FormGroup } from '@angular/forms';
import { SdTableOption } from '../../models';
import { SdTableConfigurationResult } from '../../models/table-option-config.model';
export declare class SdPopupExport implements OnInit, AfterViewInit {
    #private;
    private ref;
    private loadingService;
    private exportService;
    private notifyService;
    private translateService;
    tableOption: SdTableOption;
    columns: SdExportColumn[];
    templateName: string;
    enableCreating: boolean;
    modal: SdModal;
    listGroups: MatSelectionList;
    selected: {
        [key: string]: boolean;
    };
    files: SdExportFile[];
    export: EventEmitter<{
        file: SdExportFile;
        columns: SdExportColumn[];
        isCSV?: boolean;
    }>;
    form: FormGroup;
    set _tableOption(option: SdTableOption);
    configuration: SdTableConfigurationResult;
    private get key();
    private get tableColumns();
    private get additionalColumns();
    constructor(ref: ChangeDetectorRef, loadingService: SdLoadingService, exportService: SdExportService, notifyService: SdNotifyService, translateService: SdTranslateService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    open: () => Promise<void>;
    exportDefault: () => void;
    exportCSV: () => void;
    loadFiles: (group?: string) => Promise<void>;
    generateTemplate: () => Promise<void>;
    generateAndUploadTemplate: (fileName?: string) => Promise<{
        filePath: any;
        fileName: any;
    }>;
    onExport: (file: SdExportFile) => void;
    uploadTemplate: () => Promise<void>;
    removeFile: (file: SdExportFile) => void;
    createTemplate: () => Promise<void>;
    templateNameValidator: (val: string) => string;
}
