export declare type SdTableCommand<T = any> = SdTableCommandNormal<T> | SdTableCommandChildren<T>;
export interface SdTableCommandNormal<T = any> {
    color?: 'primary' | 'accent' | 'warn' | 'info' | 'success' | 'warning' | 'danger' | 'secondary';
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    title?: string | ((rowData: T) => string);
    disabled?: boolean | ((rowData: T) => boolean);
    hidden?: boolean | ((rowData: T) => boolean | Promise<boolean>);
    click: (rowData: T) => void;
    htmlTemplate?: (rowData: T) => string;
}
interface SdTableCommandChildren<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    title?: string | ((rowData: T) => string);
    disabled?: boolean | ((rowData: T) => boolean);
    hidden?: boolean | ((rowData: T) => boolean | Promise<boolean>);
    children: SdTableCommandNormal<T>[];
}
export {};
