import { SdBadgeColor } from '@sd-angular/core/badge';
export interface SdTableMetaSelector {
    selectable?: boolean;
    isSelected?: boolean;
    actions?: string[];
}
export interface SdTableMetaExpand {
    isExpanded?: boolean;
    isExpanding?: boolean;
    data?: any;
}
export interface SdTableDisplay {
    tooltip: string;
    badge: {
        type: 'round' | 'circle' | 'icon';
        color: SdBadgeColor;
        icon: string;
    };
    cellStyle: Record<string, string>;
    data: string;
    isHtml: boolean;
    click: () => void;
}
export interface SdTableMeta<T> {
    id?: string;
    display: Record<string, SdTableDisplay>;
    selector?: SdTableMetaSelector;
    expand?: SdTableMetaExpand;
    group?: {
        htmlTemplate?: string;
        items?: SdTableItem<T>[];
    };
}
export interface SdTableItem<T = any> {
    meta: SdTableMeta<T>;
    data: T;
}
export declare const MapToSdTableItem: <T = any>(item: T) => SdTableItem<T>;
