import { SdTableColumn } from './table-column.model';
import { SdTableCommand } from './table-command.model';
import { SdTableFilterRequest, SdTableOptionFilter } from '../services/table-filter/table-filter.model';
import { SdTableOptionExport } from './table-option-export.model';
import { SdTableOptionReload } from './table-option-reload.model';
import { SdTableOptionExpand } from './table-option-expand.model';
import { SdTableOptionSelector } from './table-option-selector.model';
import { SdTableOptionStyle } from './table-option-style.model';
import { SdTableOptionGroup } from './table-option-group.model';
import { SdTableOptionSort } from './table-option-sort.model';
import { SdTableOptionPaginate } from './table-option-paginate.model';
import { SdTableConfigOption } from './table-option-config.model';
export declare type SdTableOption<T = any> = SdTableLocalOption<T> | SdTableServerOption<T>;
interface SdTableBaseOption<T = any> {
    key?: string;
    config?: SdTableConfigOption<T>;
    selector?: SdTableOptionSelector<T>;
    expand?: SdTableOptionExpand<T>;
    sort?: SdTableOptionSort;
    paginate?: SdTableOptionPaginate;
    reload?: SdTableOptionReload<T>;
    export?: SdTableOptionExport<T>;
    group?: SdTableOptionGroup<T>;
    filter?: SdTableOptionFilter;
    commands?: SdTableCommand<T>[];
    columns: SdTableColumn<T>[];
    style?: SdTableOptionStyle<T>;
}
interface SdTableLocalOption<T = any> extends SdTableBaseOption<T> {
    type: 'local';
    items: () => T[] | Promise<T[]>;
}
interface SdTableServerOption<T = any> extends SdTableBaseOption<T> {
    type: 'server';
    items: (filterRequest: SdTableFilterRequest<T>) => Promise<{
        items: T[];
        total: number;
    }>;
}
export {};
