import { EventEmitter, ChangeDetectorRef, AfterViewInit, OnDestroy, OnInit, ElementRef } from '@angular/core';
import { FormGroup, NgForm, ValidatorFn } from '@angular/forms';
import { IFormConfiguration, SdFormControl, SdViewDefDirective } from '@sd-angular/core/common';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { SdLabelDefDirective } from '@sd-angular/core/common';
export declare class SdTextarea implements OnInit, AfterViewInit, OnDestroy {
    #private;
    private ref;
    private formConfig;
    set name(val: string);
    appearance: MatFormFieldAppearance;
    set form(val: NgForm | FormGroup);
    qcId: string;
    label: string;
    set _label(val: string);
    placeholder: string;
    rows: number;
    set model(value: any);
    modelChange: EventEmitter<any>;
    sdChange: EventEmitter<any>;
    disableErrorMessage: boolean;
    set _disableErrorMessage(val: boolean | '');
    required: boolean;
    set _required(val: boolean | '');
    maxlength: number;
    set _maxlength(val: number);
    set pattern(val: string);
    set validator(validator: (value: any) => string | Promise<string>);
    inlineError: string;
    set _inlineError(val: string);
    set disabled(val: boolean | '');
    set _autoHeight(val: boolean | '');
    textarea: ElementRef;
    sdView: SdViewDefDirective;
    sdLabelDef: SdLabelDefDirective;
    isFocused: boolean;
    formControl: SdFormControl;
    constructor(ref: ChangeDetectorRef, formConfig: IFormConfiguration);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onFocus: () => void;
    onBlur: () => void;
    onClick: () => void;
    blur: () => void;
    focus: () => void;
    customInlineErrorValidator(): ValidatorFn;
}
