import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { SdNotifyService } from '@sd-angular/core/notify';
import { SdLoadingService } from '@sd-angular/core/loading';
import { MatPaginator } from '@angular/material/paginator';
import { SdExportService } from '@sd-angular/core/export';
import { SdModal } from '@sd-angular/core/modal';
import { SdTranslateService } from '@sd-angular/core/translate';
import { SdColumnHiddenPipe } from './pipes/columm-hidden.pipe';
import { SdExcelItem, SdUploadExcelOption } from './upload-excel.model';
export declare class SdUploadExcel implements OnInit, OnDestroy {
    #private;
    private ref;
    private exportService;
    private translateService;
    private notifyService;
    private sdColumnHidden;
    private loadingService;
    private importId;
    option: SdUploadExcelOption;
    modal: SdModal;
    items: SdExcelItem[];
    hasDescription: boolean;
    showing: 'ALL' | 'SUCCESS' | 'WARNING' | 'ERROR';
    filteredItems: SdExcelItem[];
    viewItems: SdExcelItem[];
    numberOfSuccess: number;
    numberOfError: number;
    numberOfWarning: number;
    file: File;
    set paginator(paginator: MatPaginator);
    uploading: boolean;
    isUploaded: boolean;
    isDownloadTemplate: boolean;
    sdClosed: EventEmitter<any>;
    constructor(ref: ChangeDetectorRef, exportService: SdExportService, translateService: SdTranslateService, notifyService: SdNotifyService, sdColumnHidden: SdColumnHiddenPipe, loadingService: SdLoadingService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    open: () => void;
    close: () => void;
    upload: () => Promise<void>;
    validate: (excelItem: SdExcelItem, idx: number) => Promise<void>;
    accept: () => void;
    setValidation: (validates: {
        idx: number;
        messageError?: string;
        messageWarning?: string;
        messageSuccess?: string;
    }[]) => void;
    view: (showing?: 'ALL' | 'SUCCESS' | 'WARNING' | 'ERROR') => void;
    downloadTemplate: () => Promise<void>;
    export: () => Promise<void>;
    onClosed: () => void;
}
